<?
/* $Id: class.inc.php 3323 2009-06-04 14:12:57Z denis $ */

function GetClassNameByID ($ClassID)
{
  global $db;
  @$ClassArray =$db->get_var("select Class_Name from Class where Class_ID='".$ClassID."'");
  return $ClassArray;
}


/**
 *   
 *    ""   - -  :
 * size - ;
 * type -   mimetype.   - , 0 - ,    /, 1 - ,   
 * fs -   
 * 
 *   " ":
 * html -  
 * br -   - <br>
 * fck -    
 * rows, cols -   
 * 
 * @param string format
 * @param int field type
 * @return array
 */
function nc_field_parse_format ( $format, $fieldtype ) {
  $ret = array(); // 
  $format = str_replace(' ', '', $format);//  
  
  switch ($fieldtype) {
    case NC_FIELDTYPE_FILE:
      //   
      $ret['size'] = 0;
      $ret['type'] = '';
      $ret['fs'] = NC_FS_PROTECTED;
      $ret['download'] = 0;
      //    -    
      if ( !$format ) break;
      //    :   size:type1/type,type2/type:fs1
      //  
      if ( ( $fs_start = strpos($format, ':fs') ) !== false ) { //     
        $ret['fs'] = intval(substr($format, $fs_start + 3, 1));
        //     
        $format = str_replace( ":fs".$ret['fs'], '', $format);   
      }
      if ( !$format ) break;
      $format_array = explode(':', $format);
      if ( empty($format_array) ) break;
      if ( $format_array[0] ) $ret['size'] = $format_array[0]; // 
      // mimetype
      if ( $format_array[1] ) {
        $fileformat = explode(",", $format_array[1]); //   
        foreach ( $fileformat as $k => $v ) {
          $ret['type'][$k] = explode('/', $v);   
        }    
      }
      break;
      
    case NC_FIELDTYPE_TEXT:
      //   
      $ret['rows'] = 5;  //  
      $ret['cols'] = 60; //  
      $ret['html'] = 0;  //  
      $ret['br']   = 0;  //   - br
      $ret['fck']  = 0;  //    
      
      if ( !$format ) return $ret;
      
      $params = array('html', 'br', 'fck');
      //    
      foreach ( $params as $param ) {
        if ( ( $start = strpos($format, $param) ) !== false ) { 
          $ret[$param] = intval(substr($format, $start + strlen($param) + 1, 1));
        }  
      }
      
      //     
      if ( $format{0} > 0 ) { 
        $format = strtok($format, ';');
        $ret['rows'] = strtok($format, ':');
        $ret['cols'] = strtok(':');
      }
      
      break;
      
  }
 
  return $ret;
}



/**
 *         
 *    
 *     ,     -
 *
 * @param int message - id 
 * @param int field_src - id  
 * @param int field_dst - id  
 * @param int classID () id 
 * 
 * @todo     
 * @todo      (,   )
 * @return bool
 */
function nc_copy_filefield ( $message, $field_src, $field_dst, $classID = 0 ) {
  global $nc_core;
  
  //    ,     
  if ( !$classID ) $classID = $nc_core->db->get_var("SELECT `Class_ID` FROM `Field` WHERE  `Field_ID` = '".intval($field_src)."'");
 
  //  
  $message += 0;
  $field_src += 0;
  $field_dst += 0;
  $classID += 0;
  if ( !$message || !$field_src || !$field_dst || !$classID ) return 0; 
  
  #   
  //   
  $field_name_src = $nc_core->db->get_var("SELECT `Field_Name` FROM `Field` WHERE `Field_ID` = '".$field_src."'"); 
  if ( !$field_name_src ) return 0;
  
  //     
  $message_field = $nc_core->db->get_row("SELECT * FROM `Message".$classID."` WHERE  `Message_ID` = '".$message."'", ARRAY_A);
  $file_data = explode(':',  $message_field[$field_name_src]);
  $file_name = $file_data[0];
  $file_type = $file_data[1];
  $file_size = $file_data[2];
  $ext = substr($file_name, strrpos($file_name, ".")); //  
  //     Filetable ?
  $filetable = $nc_core->db->get_row("SELECT * FROM `Filetable` 
                                          WHERE `Message_ID` = '".intval($message)."' AND `Field_ID` = '".intval($field_src)."'", ARRAY_A);
  //     
  if ( $filetable ) { //    protected
    $path_src = rtrim($nc_core->FILES_FOLDER, '/').$filetable['File_Path'].$filetable['Virt_Name'];
  }
  else {
    if ( $file_data[3] ) { // orignal
      $path_src = $nc_core->FILES_FOLDER.$file_data[3];    
    }
    else { // simple
      $path_src = $nc_core->FILES_FOLDER.$field_src."_".$message.$ext;
      
    }
  }
  
  
  # 
  //    -
  $field_info_desc = $nc_core->db->get_row("SELECT `Field_Name`, `Format` FROM `Field` WHERE `Field_ID` = '".$field_dst."'", ARRAY_A);
  if ( !$field_info_desc) return 0;
  
  //  
  require_once($nc_core->INCLUDE_FOLDER."s_files.inc.php");
  DeleteFile($field_dst, $field_info_desc['Field_Name'], $classID, 0, $message);
  
  //    
  $fs = nc_field_parse_format($field_info_desc['Format'], NC_FIELDTYPE_FILE);
  $fs = $fs['fs'];

  //       
  $in_db = $file_name.":".$file_type.":".$file_size; // ,    
  switch ( $fs ) {
    case NC_FS_PROTECTED:
      $path_dsc = $message_field['Subdivision_ID'].'/'.$message_field['Sub_Class_ID'].'/';
      $name_dsc =  md5($file_name.date("H:i:s d.m.Y").uniqid("netcat"));
      $nc_core->db->query("INSERT INTO `Filetable`(Real_Name, Virt_Name, File_Path, File_Type, File_Size, Message_ID, Field_ID)
                           VALUES('".$file_name."', '".$name_dsc."', '/".$path_dsc."','".$file_type."', '".$file_size."', '".$message."', '".$field_dst."')"); 
      break;
    case NC_FS_ORIGINAL:
      $path_dsc = $message_field['Subdivision_ID'].'/'.$message_field['Sub_Class_ID'].'/';
      $name_dsc = nc_get_filename_for_original_fs($file_name, $nc_core->FILES_FOLDER.$path_dsc);
      $in_db .= ":".$path_dsc.$name_dsc;
      break;
    case NC_FS_SIMPLE:
      $path_dsc = '';
      $name_dsc = $field_dst."_".$message.$ext;
      break;
  }
      
  //    
  $nc_core->db->query("UPDATE `Message".$classID."` SET `".$field_info_desc['Field_Name']."` = '".$in_db."' WHERE `Message_ID` = '".$message."'");
  print $nc_core->FILES_FOLDER.$path_dsc.$name_dsc;
  //  
  copy($path_src, $nc_core->FILES_FOLDER.$path_dsc.$name_dsc);
  
  return 1;
  
}

/**
 *       
 *
 * @param str   
 * @param str   
 * @param array     
 * @return str
 */
function nc_get_filename_for_original_fs ( $file_name, $path , $disallow = null) {
  global $nc_core;

  $use_index = false; //      
  if ( !empty($disallow) && in_array($file_name, $disallow ) ) $use_index = true;
  
  $file_name = nc_transliterate($file_name);
  $file_name = preg_replace("/[^a-z0-9.]/is", "_", $file_name);
  if ( file_exists($path.$file_name) ) $use_index = true;

  if ( !$use_index ) return $file_name;
  
  $k = 0;
  $ext = substr($file_name, strrpos($file_name, "."));
  
  while ( file_exists($path.($temp = substr($file_name,0, strrpos($file_name, "."))."_".$k.$ext)) 
			               || in_array( $temp , (array)$disallow)) {
		$k++; 
  }
  $file_name = $temp;

  return $file_name;
}

?>
