<?php
/* $Id: connect_io.php 3250 2009-05-13 14:10:59Z vadim $ */

$NETCAT_FOLDER = join( strstr(__FILE__, "/") ? "/" : "\\", array_slice( preg_split("/[\/\\\]+/", __FILE__), 0, -2 ) ).( strstr(__FILE__, "/") ? "/" : "\\" );
@include_once ($NETCAT_FOLDER."vars.inc.php");

// PHP version must be >= 5.1
if ( preg_match("/^(\d)\.(\d)/is", phpversion(), $matches) ) {
  if ( intval($matches[1].$matches[2]) < 51 ) die("<b style='color:#A00'>PHP 5.1 or higher required!</b>");
}

// need to extract GLOBALS
include_once ($INCLUDE_FOLDER."s_extract.inc.php");

// init db interface
try {
  // connect to database
  $nc_core->db->set_connect($MYSQL_DB_NAME, $MYSQL_USER, $MYSQL_PASSWORD, $MYSQL_HOST);
  // set db for compatibillity
  $db = $nc_core->db;
  // if MySQL tables not exist
  if ( !$db->get_var("SHOW TABLES LIKE 'Settings'") ) {
    if ( file_exists($nc_core->get_variable("DOCUMENT_ROOT").$nc_core->get_variable("SUB_FOLDER")."/install/index.php") ) {
      header("Location: ".$nc_core->get_variable("SUB_FOLDER")."/install/");
    }
    // nothing to do
    die("<b style='color:#A00'>System not installed!</b>");    
  }
}
catch (Exception $e) {
  // put into the log
  $nc_core->errorMessage($e);
  // show message
  die ( $e->getMessage() );
}

// what to do when with MySQL errors
if ($SHOW_MYSQL_ERRORS=="on") {
  $db->show_errors();
}
else {
  $db->hide_errors();
}

// link to object
$LinkID = &$db->dbh;

// set default names
if ( (float)mysql_get_server_info($LinkID) >= 4.1 ) {
  if (!$MYSQL_CHARSET) $MYSQL_CHARSET = 'cp1251';
  $db->query("SET NAMES '".$MYSQL_CHARSET."'");
  $db->query("SET sql_mode=''");
}

?>