<?php
/* $Id: function.inc.php 3248 2009-05-13 08:32:52Z denis $ */
$NETCAT_FOLDER = join( strstr(__FILE__, "/") ? "/" : "\\", array_slice( preg_split("/[\/\\\]+/", __FILE__), 0, -4 ) ).( strstr(__FILE__, "/") ? "/" : "\\" );
@include_once ($NETCAT_FOLDER."vars.inc.php");

global $MODULE_FOLDER;
//  -
include ($MODULE_FOLDER."auth/nc_auth.relation.php");

function AttemptToAuthorize()
{
	$sname  = session_name();
	unset($perm);

	global $db, $perm;
	global $AUTHORIZE_BY;
	global $PHP_AUTH_USER, $PHP_AUTH_PW, $PHP_AUTH_SID, $PHP_AUTH_LANG;
	global $AUTHORIZATION_TYPE, $MODULE_VARS, $ADMIN_AUTHTIME, $HTTP_HOST, $SUB_FOLDER;
	global $AUTH_USER_ID, $AUTH_USER_GROUP;
	global $$sname, $current_user, $catalogue;

	$IP_CHECK_LEVEL = &$MODULE_VARS['auth']['IP_CHECK_LEVEL'];
	$IpCheckLevel = ( $IP_CHECK_LEVEL != '' && $IP_CHECK_LEVEL >= 0 && $IP_CHECK_LEVEL <=4 ? (int)$IP_CHECK_LEVEL : 2);

	$AUTH_USER_ID    = 0;
	$AUTH_USER_GROUP = 0;

	if ($AUTHORIZATION_TYPE != 'http') {
		if ($$sname) {
			$_GET[session_name()]  = $$sname;
			$_POST[session_name()] = $$sname;
		}
		else {
			$session_id = md5(uniqid(rand(), 1));
			session_id($session_id);
		}
		session_start();
		$glbSid = session_id();
		if ($_SESSION['User']['IsLogin'] == "1") {
			if ($_SESSION['User']['IP'] != getenv("REMOTE_ADDR")) header ("Location: ".$SUB_FOLDER);
			if ((time()-$_SESSION['User']['datetime']) > ini_get('session.gc_maxlifetime')) unset($_SESSION['User']);
		}
		$_SESSION['User']['datetime'] = time();
		if ($AUTHORIZATION_TYPE == 'session' && !$_SESSION['User']['ID'] && $_SESSION_USER_ID != "0") {$AUTH_USER_ID = $_SESSION['User']['ID'];}
	}


	//  IP 
	if ($AUTH_TYPE != 'http') {

		if ($IpCheckLevel == 0) {
			$SqlCheckIp = '';
		}
		elseif ($IpCheckLevel == 4) {
			$SqlCheckIp = ' AND s.UserIP = '.sprintf("%u", ip2long($_SERVER['REMOTE_ADDR']));
		}
		else {
			$IpVal = explode('.', $_SERVER['REMOTE_ADDR'],$IpCheckLevel+1);
			array_pop($IpVal);
			$IpVal = implode('.', $IpVal);
			$UserIPBegin = $IpVal.str_repeat('.0', 4-$IpCheckLevel);
			$UserIPEnd = $IpVal.str_repeat('.255', 4-$IpCheckLevel);
			$SqlCheckIp = ' AND s.UserIP >= '.sprintf("%u", ip2long($UserIPBegin)).' AND s.UserIP <= '.sprintf("%u", ip2long($UserIPEnd));
		}
	}

	$query_where_cat = $MODULE_VARS['auth']['USER_BIND_TO_CATALOGUE'] ? " AND u.Catalogue_ID IN(0,".$catalogue.")" : "";

	// HTTP 
	if ($AUTHORIZATION_TYPE == 'http') {
		$user_result = $db->get_results("SELECT u.*, ug.`PermissionGroup_ID` AS PermissionGroups_ID
			                           FROM `User` as u, `User_Group` as ug 
			                           WHERE u.`".$AUTHORIZE_BY."` = '".$PHP_AUTH_USER."' 
			                           AND Password=PASSWORD('".$PHP_AUTH_PW."')
			                           AND u.`User_ID` = ug.`User_ID`
			                           ", ARRAY_A);

	}
	// SESSION 
	elseif ($AUTHORIZATION_TYPE == 'session') {
		$user_result = $db->get_results("SELECT u.*, ug.`PermissionGroup_ID` AS PermissionGroups_ID, s.`LoginSave`
			                            FROM (`User` as u, `User_Group` as ug)
			                            RIGHT JOIN `Session` AS s
			                            ON u.User_ID = s.User_ID
			                            WHERE u.Checked = 1 
			                            AND u.`User_ID` = ug.`User_ID` 
			                            AND s.Session_ID = '".$$sname."' 
			                            AND s.SessionTime > ".time().$SqlCheckIp.$query_where_cat, ARRAY_A);

	}
	// COOKIE 
	elseif ($AUTHORIZATION_TYPE == 'cookie') {
		$user_result = $db->get_results("SELECT u.*, ug.`PermissionGroup_ID` AS PermissionGroups_ID,  s.`LoginSave`
			                            FROM (`User` as u, `User_Group` as ug)
			                            RIGHT JOIN Session AS s
			                            ON u.User_ID = s.User_ID
			                            WHERE u.Checked = 1 AND u.`User_ID` = ug.`User_ID`  
			                            AND s.Session_ID = '".$PHP_AUTH_SID."' AND s.SessionTime > ".time().$SqlCheckIp.$query_where_cat, ARRAY_A);
	}




	//  
	if ($user_result) {
	  $current_user = $user_result[0];
	  unset($current_user['PermissionGroups_ID']);
	  foreach ( $user_result as $row ) {
	   $current_user["Permission_Group"][] = $row['PermissionGroups_ID'];
	  }
		$AUTH_USER_ID    = $current_user['User_ID'];
		$AUTH_USER_GROUP = $current_user['PermissionGroup_ID'];
		$PHP_AUTH_USER   = $current_user[$AUTHORIZE_BY];
		if ( $AUTHORIZATION_TYPE != 'http') $PHP_AUTH_PW = $Password;
		$LoginSave       = ($current_user['LoginSave'] || $ADMIN_AUTHTYPE == 'always' ? 1 : 0);
		$Catalogue_ID    = $current_user['Catalogue_ID'];

		$SessionTime = ($ADMIN_AUTHTIME ? time()+$ADMIN_AUTHTIME : time()+24*3600);

		if ($AUTHORIZATION_TYPE == 'session') {
			$db->query("UPDATE Session SET SessionTime = ".$SessionTime." WHERE Session_ID = '".$$sname."'");
		}
		elseif ($AUTHORIZATION_TYPE == 'cookie') {
			$db->query("UPDATE Session SET SessionTime = ".$SessionTime." WHERE Session_ID = '".$PHP_AUTH_SID."'");
			if (!$LoginSave) $SessionTime = 0;
			$cookie_domain = ($MODULE_VARS['auth']['COOKIES_WITH_SUBDOMAIN'] ? str_replace("www.", "", $HTTP_HOST) : NULL);
			setcookie('PHP_AUTH_SID', $PHP_AUTH_SID, $SessionTime, "/", $cookie_domain);
			setcookie('PHP_AUTH_LANG', $PHP_AUTH_LANG, $SessionTime, "/", $cookie_domain);
		}


	}
	
	// 
	else {
		$SessionTime = time()+($ADMIN_AUTHTIME ? $ADMIN_AUTHTIME : 24*3600);
		$PHP_AUTH_SID = ($$sname ? $$sname : $glbSid);
		$PHP_AUTH_USER = '';
		$PHP_AUTH_PW = '';
		
		$update_res = $db->query("UPDATE Session SET SessionTime = IF (SessionTime=".$SessionTime.", SessionTime+1,".$SessionTime.") WHERE Session_ID = '".$PHP_AUTH_SID."'");
		if (!$update_res) {
			$db->query("INSERT INTO Session (Session_ID, User_ID, SessionStart, SessionTime, UserIP, Catalogue_ID) VALUES ('".$PHP_AUTH_SID."', 0, ".time().", ".$SessionTime.", ".sprintf("%u", ip2long($_SERVER['REMOTE_ADDR'])).", ".$catalogue.")");
			//   
			if (!rand(0,50)) $db->query("DELETE FROM Session WHERE User_ID = 0 AND SessionTime < ".($SessionTime-300));
		}
	}

	if ($AUTH_USER_ID) {
		$perm = new Permission ($AUTH_USER_ID,0, $user_result);
	}
	
	else {
		return false;
	}
}


function UserLoginForm($IsReturn = 0)
{
	global $HTTP_ROOT_PATH, $AUTH_USER, $REQUEST_URI, $REQUESTED_FROM, $REQUEST_METHOD, $SUB_FOLDER;
	global $db, $catalogue, $sub, $cc, $AUTH_USER_ID, $AUTHORIZATION_TYPE, $ADMIN_AUTHTYPE, $REQUESTED_BY;
	
	if ($AUTH_USER_ID) return;
	
	if (!$REQUESTED_FROM) $REQUESTED_FROM = $REQUEST_URI;
	if (!isset($REQUESTED_BY) || isset($REQUESTED_BY) && (strtoupper($REQUESTED_BY) != 'GET' && strtoupper($REQUESTED_BY) != 'POST')) $REQUESTED_BY = $REQUEST_METHOD;

	$isDisable = nc_auth_get_settings('UserLoginFormIsDisable');
	if ($isDisable) return;
  
	$template = nc_auth_get_settings('UserLoginForm');

	eval ('$result = "'.$template.'";');

	if ($IsReturn) {
		return $result;
	}
	else {
		echo $result;
	}
}


function ChangePasswordForm($IsResult = 0)
{
	global $db, $catalogue, $sub, $cc;
	global $HTTP_ROOT_PATH, $SUB_FOLDER;

	if (isset($_REQUEST['uid'])) $uid = (int)$_REQUEST['uid'];
	if (isset($_REQUEST['ucc'])) $ucc = htmlspecialchars($_REQUEST['ucc'], ENT_QUOTES);
  
	$template = nc_auth_get_settings('ChangePasswordForm');

	eval ('$result = "'.$template.'";');

	if ($IsResult) {
		return $result;
	}
	else {
		echo $result;
	}
}


function PasswordRecoveryForm($IsResult = 0)
{
	global $Login, $Email;
	global $db, $catalogue, $sub, $cc;
	global $HTTP_ROOT_PATH, $SUB_FOLDER;

	$template = nc_auth_get_settings('PasswordRecoveryForm');
	eval ('$result = "'.$template.'";');

	if ($IsResult) {
		return $result;
	}
	else {
		echo $result;
	}
}


function GetAllProjectDomains ()
{
	global $db, $DOMAIN_NAME, $SUB_FOLDER;

	$res = $db->get_results("SELECT IF(LOCATE('.',Domain),Domain,IF(Domain<>'',CONCAT(Domain,'.".$DOMAIN_NAME."'),'".$DOMAIN_NAME."')),Mirrors FROM Catalogue ORDER BY Priority", ARRAY_N);
	$k = 0;
	$CatCount = $db->num_rows;
	for ($i=0; $i<$CatCount; $i++) {
		list($Domain,$Mirrors) = $res[$i];
		$DomainArray[$k] = $Domain;
		$MirrorArray = explode("\n",$Mirrors);
		for ($j=0;$j<count($MirrorArray);$j++) {
			$k++;
			$DomainArray[$k] = trim($MirrorArray[$j]);
		}
	}
	return ($DomainArray);
}


/*======= USER FUNCTIONS =======*/


/**
 *     " "
 * name of the function by N
 *
 * @param integer ID  (optional)
 * @return string     
 */
function nc_auth_regform_url($catalogue_id=0)
{
	global $db, $SUB_FOLDER;

	$catalogue_id = ($catalogue_id ? (int)$catalogue_id : $GLOBALS['catalogue']);

	$url = $db->get_var("SELECT CONCAT(sub.Hidden_URL, cc.EnglishName, '.html')
		FROM Subdivision as sub, Sub_Class as cc, Class as class
		WHERE class.System_Table_ID=3
		AND class.Class_ID=cc.Class_ID
		AND cc.Catalogue_ID = $catalogue_id
		AND cc.DefaultAction='add'
		AND cc.Checked = 1
		AND cc.Subdivision_ID=sub.Subdivision_ID
		LIMIT 1");
	return $SUB_FOLDER.$url;
}


/**
 * url    
 *
 * @param mixed $User_ID   (optional)
 * @return mixed     
 */
function nc_auth_profile_url($User_ID = 0)
{
	global $db;
	global $catalogue;
	global $MODULE_VARS, $SUB_FOLDER;

	$UserListCc = $MODULE_VARS['auth']['USER_LIST_CC'];
	if ($UserListCc) {
		if (!$MODULE_VARS['auth']['UserListUrl']) {
			$MODULE_VARS['auth']['UserListUrl'] = $db->get_var("SELECT CONCAT(sd.Hidden_URL, sc.EnglishName)
				FROM Sub_Class AS sc
				LEFT JOIN Subdivision AS sd
				ON sc.Subdivision_ID = sd.Subdivision_ID
				WHERE sc.Catalogue_ID = ".(int)$catalogue." AND sc.Sub_Class_ID IN (".$UserListCc.")");
		}
		$url = $MODULE_VARS['auth']['UserListUrl'];

		if (is_array($User_ID)) {
			foreach ($User_ID as $id) $result[] = $SUB_FOLDER.$url.'_'.$id.'.html';
			return $result;
		}
		elseif ($User_ID) {
			return $SUB_FOLDER.$url.'_'.(int)$User_ID.'.html';
		}
		else {
			return $SUB_FOLDER.$url.'_';
		}

	}
	else {
		return false;
	}


}


/**
 *  online
 *
 * @param mixed $template        (optional)
 * @param string $select_fields     (optional)
 * @return mixed
 */
function nc_auth_users_online($template = NULL, $select_fields = NULL)
{
	global $db, $catalogue;
	global $MODULE_VARS, $ADMIN_AUTHTIME, $AUTHORIZE_BY, $SUB_FOLDER;

	$result = NULL;
	$TimeLeft = ($ADMIN_AUTHTIME ? time()+$ADMIN_AUTHTIME : time()+24*3600) - $MODULE_VARS['auth']['USER_ONLINE_TIME_LEFT'];
	$tags  = array('%NAME', '%URL');
	$tags2 = array('%GUESTS', '%REGISTERED', '%ONLINE');
	$select_fields   = ($select_fields ? $select_fields.', ' : 'u.'.$AUTHORIZE_BY.' AS Name, ');
	$query_where_cat = $MODULE_VARS['auth']['USER_BIND_TO_CATALOGUE'] ? "Catalogue_ID IN(0,".$catalogue.")" : "";

	switch ($template) {
		case ARRAY_N:
			return (array)$db->get_col("SELECT User_ID
				FROM Session
				WHERE User_ID != 0 AND SessionTime>".$TimeLeft.($query_where_cat ? " AND ".$query_where_cat : "")."
				GROUP BY User_ID
				ORDER BY User_ID");
			break;

		case ARRAY_A:
			return (array)$db->get_results("SELECT u.User_ID, ".$select_fields."CONCAT('".nc_auth_profile_url()."', u.User_ID, '.html') AS `Url`
				FROM User AS u
				INNER JOIN Session AS s
				ON u.User_ID=s.User_ID
				WHERE s.SessionTime>".$TimeLeft.($query_where_cat ? " AND s.".$query_where_cat : "")."
				GROUP BY u.User_ID
				ORDER BY Name", ARRAY_A);
			break;
	}

	if (!$template) {
		unset ($template);
		$template['prefix']  = "";
		$template['suffix']  = "";
		$template['divider'] = ", ";
		$template['link']    = "<a href='%URL'>%NAME</a>";
	}

	$Guests = $db->get_var("SELECT COUNT(Session_ID)
		FROM Session
		WHERE User_ID=0 AND SessionTime>".$TimeLeft.($query_where_cat ? " AND ".$query_where_cat : ""));

	if (is_array($template)) {

		$OnlineUsers = $db->get_results("SELECT u.".$AUTHORIZE_BY." AS `Name`, CONCAT('".nc_auth_profile_url()."', u.User_ID, '.html') AS `Url`
			FROM User AS u
			INNER JOIN Session AS s
			ON u.User_ID=s.User_ID
			WHERE s.User_ID!=0 AND s.SessionTime>".$TimeLeft.($query_where_cat ? " AND s.".$query_where_cat : "")."
			GROUP BY u.User_ID
			ORDER BY Name", ARRAY_A);

		if ($Registered = count($OnlineUsers)) {
			if ($template['link']) {
				foreach ($OnlineUsers as $user) $result[] = str_replace($tags, $user, $template['link']);
				$result = join(($template['divider'] ? $template['divider'] : ''), $result);
			}
			$result = ($template['prefix'] ? $template['prefix'] : '').$result.($template['suffix'] ? $template['suffix'] : '');

			$result = str_replace($tags2, array($Guests, $Registered, $Guests+$Registered), $result);
		}


	}
	else {
		$Registered = count($db->get_results("SELECT User_ID
			FROM Session
			WHERE User_ID != 0 AND SessionTime>".$TimeLeft.($query_where_cat ? " AND ".$query_where_cat : "")."
			GROUP BY User_ID", ARRAY_N));
		$result = str_replace($tags2, array($Guests, $Registered, $Guests+$Registered), $template);
	}


	return $result;
}


/**
 *    
 * 
 * @param int $User_ID  
 */
function nc_auth_is_online($User_ID)
{	
	static $online;
	
	if (!is_array($online)) {
		$online = nc_auth_users_online(ARRAY_N);
	}
	
	return is_array($online) && in_array($User_ID, $online) ? true : false;
}


/**
 *        
 *
 * @param int $User_ID   (optional)
 * @return int
 */
function nc_auth_messages_new($User_ID = 0, $Sub_Class_ID = 0)
{
	global $db, $current_user, $catalogue;
	global $MODULE_VARS;

	if (!$current_user) return false;

	if (!$User_ID) $User_ID = $current_user['User_ID'];

	if (!isset($MODULE_VARS['auth']['UserMessagesNew'])) {
		$MODULE_VARS['auth']['UserMessagesNew'] = $db->get_var("SELECT COUNT(m.Message_ID)
			FROM Message".$MODULE_VARS['auth']['USER_MESSAGES_CLASS']." AS m
			RIGHT JOIN Sub_Class AS s
			ON m.Sub_Class_ID = s.Sub_Class_ID
			WHERE m.Status = 0 AND m.ToUser = ".$User_ID." AND s.Catalogue_ID = ".$catalogue.($Sub_Class_ID ? " AND m.Sub_Class_ID = ".(int)$Sub_Class_ID : ""));
	}
	return $MODULE_VARS['auth']['UserMessagesNew'];
}


/**
 * URL     /   
 *
 * @param int $User_ID   ()    (optional)
 * @param int $Sub_Class_ID       (optional)
 * @return string
 */
function nc_auth_messages_url($User_ID = 0, $Sub_Class_ID = 0)
{
	global $db, $catalogue;
	global $MODULE_VARS, $SUB_FOLDER;

	if (!isset($MODULE_VARS['auth']['UserMessagesUrl'])) {
		$res = $db->get_row("SELECT sd.Hidden_URL, sc.EnglishName
			FROM Sub_Class AS sc
			LEFT JOIN Subdivision AS sd
			ON sc.Subdivision_ID = sd.Subdivision_ID
			WHERE sc.Class_ID = ".$MODULE_VARS['auth']['USER_MESSAGES_CLASS']." AND sc.Catalogue_ID = ".$catalogue.($Sub_Class_ID ? " AND sc.Sub_Class_ID = ".(int)$Sub_Class_ID : "")."
			LIMIT 1", ARRAY_A);

		$MODULE_VARS['auth']['UserMessagesClassEnName'] = $res['EnglishName'];
		$MODULE_VARS['auth']['UserMessagesUrl'] = $res['Hidden_URL'];
	}

	return $SUB_FOLDER.$MODULE_VARS['auth']['UserMessagesUrl'].($User_ID ? "add_".$MODULE_VARS['auth']['UserMessagesClassEnName'].".html?uid=".$User_ID : "");
}


/**
 *      
 *
 * @param  item  ,   -   
 * @return 
 */
function nc_auth_get_settings ( $item = '' ) {
  global $db;
  static $storage;
  
  if ( empty($storage) ) {
    $res = $db->get_results("SELECT `SettingsKey`, `Value` FROM `Auth_Settings`", ARRAY_A);
    if ( !empty($res) ) {
      foreach ( $res as $value ) {
        $storage[$value['SettingsKey']] = $value['Value'];
      }
    }
  }
 
  if ( $item ) return $storage[$item];
  
  return $storage;
}

/*
 * OpenID url normilize function
 *
 * @param string url
 *
 * @return string normilized url
 */
function nc_auth_normalize_openid_url ($url) {
  
  $t_url = parse_url($url);
  $t_url['host'] = preg_replace("/.*www\.(.*)/i", "\$1", $t_url['host']);
  $t_url['path'] = preg_replace("/.*www\.(.*)/i", "\$1", $t_url['path']);
  $url = ($t_url['scheme'] ? $t_url['scheme']."://" : "").$t_url['host'].($t_url['path']!="/" ? $t_url['path'] : NULL).($t_url['query'] ? '?'.$t_url['query'] : '');
  
  return $url;
}

function nc_auth_openid_field_exist () {
  global $db;
  static $passed = false;

  if (!$passed) {
    $result = $db->get_var('SELECT COUNT(*) FROM `Field` WHERE `System_Table_ID` = 3 AND `TypeOfData_ID` = 11');
    $passed = true;
  }
  
  return $result;
}

function nc_auth_openid_possibility () {
  // oO
  return false;
  // set true as default
  $result = true;
  // get all installed PHP extensions
  $extensions = get_loaded_extensions();
  // check CURL extension installed on the server
  if ( !function_exists("curl_init") ) $result = false;
  // check bcmath or gmp (more useful)
  if ( !( in_array("bcmath", $extensions) || in_array("gmp", $extensions) ) ) $result = false;
  // check XML support
  if ( !( in_array("dom", $extensions) || in_array("domxml", $extensions) ) ) $result = false;
  // return result
  return $result;
}

function nc_auth_openid_do_includes() {
	global $INCLUDE_FOLDER;
	
	// set include path
	set_include_path($INCLUDE_FOLDER."lib");
	// Require the OpenID consumer code.
	require_once "Auth/OpenID/Consumer.php";
	// Require the "file store" module, which we'll need to store OpenID information.
	require_once "Auth/OpenID/FileStore.php";
	// Require the Simple Registration extension API.
	require_once "Auth/OpenID/SReg.php";
	// Require the PAPE extension module.
	require_once "Auth/OpenID/PAPE.php";
}

/*global $pape_policy_uris;
$pape_policy_uris = array(
	PAPE_AUTH_MULTI_FACTOR_PHYSICAL,
	PAPE_AUTH_MULTI_FACTOR,
	PAPE_AUTH_PHISHING_RESISTANT
);*/

function nc_auth_openid_get_store() {
  global $TMP_FOLDER;
  
  /**
     * This is where the example will store its OpenID information.
     * You should change this path if you want the example store to be
     * created elsewhere.  After you're done playing with the example
     * script, you'll have to remove this directory manually.
     */
  $store_path = $TMP_FOLDER."_openid";

  if (!file_exists($store_path) && !mkdir($store_path)) {
    print "Could not create the FileStore directory '".$store_path."'. Please check the effective permissions.";
    exit(0);
  }

  return new Auth_OpenID_FileStore($store_path);
}

function nc_auth_openid_get_consumer () {
    /**
     * Create a consumer object using the store object created
     * earlier.
     */
  $store = nc_auth_openid_get_store ();
  $consumer =& new Auth_OpenID_Consumer($store);
  
  return $consumer;
}

function nc_auth_openid_get_scheme() {
  $scheme = 'http';
  if ( isset($_SERVER['HTTPS']) and $_SERVER['HTTPS'] == 'on' ) {
    $scheme.= 's';
  }
  return $scheme;
}

function nc_auth_openid_get_return_to () {

  $result = sprintf("%s://%s:%s%s/",
    nc_auth_openid_get_scheme(), $_SERVER['SERVER_NAME'],
    $_SERVER['SERVER_PORT'],
    dirname($_SERVER['PHP_SELF'])
  );
    
	return $result;
}

function nc_auth_openid_get_trust_root () {

  $result = sprintf("%s://%s:%s%s/",
    nc_auth_openid_get_scheme(), $_SERVER['SERVER_NAME'],
    $_SERVER['SERVER_PORT'],
    dirname($_SERVER['PHP_SELF'])
  );
  
  return $result;
}

?>
